#pragma once

#include "shapeobjects.h"
#include "xprdef.h"

#include <string>

//*******************************************************************************
// Helper class
class CBounds
{
public:
	CBounds(double x1, double y1, double x2, double y2);
	double xMin, yMin, xMax, yMax;
};


//*******************************************************************************
// C[!output SAFE_PROJECT_NAME]Exporter class
class C[!output SAFE_PROJECT_NAME]Exporter
{
public:
	C[!output SAFE_PROJECT_NAME]Exporter(BatchExportBeginInfo *pInfo);
	~C[!output SAFE_PROJECT_NAME]Exporter(void);

	static const wchar_t* GetName();
	static const wchar_t* GetDescription();
	static const wchar_t* GetLastErrMsg();
	static const wchar_t* GetInfo();

	static bool SupportsType(ShapeType t);

	bool OnPreExportLayer(PreExportInfo *pInfo);

	bool OnExportShape(ExportShapeInfo *pInfo);

	bool OnPostExportLayer(ShapeType type);

[!if SETTINGS_DIALOG]
	static void OnSettings();

[!endif]
protected:
	size_t m_nNumberOfThemesInBatch;
	CBounds m_bounds;

	COLORREF m_clrBkgnd;

	static std::wstring g_strErr;
[!if FILE_SUPPORT]
	std::string m_strFileName;
[!endif]
};

