// [!output SAFE_PROJECT_NAME].cpp : Defines the entry points for the DLL application.
//

#include "stdafx.h"
#include "./xprdef.h"

#include "[!output SAFE_PROJECT_NAME]Exporter.h"



//*******************************************************************************
// Name : pTheExporter
// Desc : 
//*******************************************************************************
C[!output SAFE_PROJECT_NAME]Exporter *pTheExporter = NULL;


//*******************************************************************************
// Name : fnGetName
// Desc : This is a user friendly name used in menues and else-where in ShapeUp.
//*******************************************************************************
const wchar_t* __cdecl fnGetName()
{
	return C[!output SAFE_PROJECT_NAME]Exporter::GetName();
}


//*******************************************************************************
// Name : fnGetDescription
// Desc : This is a one-line description of this exporter used in ShapeUp.
//*******************************************************************************
const wchar_t* __cdecl fnGetDescription()
{
	return C[!output SAFE_PROJECT_NAME]Exporter::GetDescription();
}


//*******************************************************************************
// Name : fnGetLastErrMsg
// Desc : Return the last encountered error.
//*******************************************************************************
const wchar_t* __cdecl fnGetLastErrMsg()
{
	return C[!output SAFE_PROJECT_NAME]Exporter::GetLastErrMsg();
}


//*******************************************************************************
// Name : fnGetInfo
// Desc : Information displayed if the user choses info from Tools|Options
//*******************************************************************************
const wchar_t* __cdecl fnGetInfo()
{
	return C[!output SAFE_PROJECT_NAME]Exporter::GetInfo();
}


//*******************************************************************************
// Name : fnSupportsType
// Desc : What types of object do this Exporter suport.
//*******************************************************************************
bool __cdecl fnSupportsType(ShapeType t)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	return C[!output SAFE_PROJECT_NAME]Exporter::SupportsType(t);
}


//*******************************************************************************
// Name : fnBatchExportBegin
// Desc : Create a new exporter object
//*******************************************************************************
void __cdecl fnBatchExportBegin(BatchExportBeginInfo *pInfo)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	ASSERT(pTheExporter == NULL);

	pTheExporter = new C[!output SAFE_PROJECT_NAME]Exporter(pInfo);
}


//*******************************************************************************
// Name : fnBatchExportEnd
// Desc : Destroys our exporter object
//*******************************************************************************
void __cdecl fnBatchExportEnd()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	ASSERT(pTheExporter != NULL);

	delete pTheExporter;
	pTheExporter = NULL;
}


//*******************************************************************************
// Name : fnVersion
// Desc : Curent Exporter interface version.
//*******************************************************************************
size_t __cdecl fnVersion()
{
	return EXPORTER_PLUGIN_INTERFACE_VERSION;
}


//*******************************************************************************
// Name : fnPreExport
// Desc : Perform any actions before we start exporting shapes in current layer.
//*******************************************************************************
bool __cdecl fnPreExport(PreExportInfo *pInfo)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	ASSERT(pTheExporter != NULL);

	if (pTheExporter == NULL)
		return false;

	return pTheExporter->OnPreExportLayer(pInfo);
}


//*******************************************************************************
// Name : fnExportShape
// Desc : Export one shape.
//*******************************************************************************
bool __cdecl fnExportShape(ExportShapeInfo *pInfo)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	ASSERT(pTheExporter != NULL);

	if (pTheExporter == NULL)
		return false;

	return pTheExporter->OnExportShape(pInfo);
}


//*******************************************************************************
// Name : fnPostExport
// Desc : Clean-up this theme
//*******************************************************************************
bool __cdecl fnPostExport( ShapeType type, bool /* bRetCode */ )
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	ASSERT(pTheExporter != NULL);

	if (pTheExporter == NULL)
		return false;

	if (!pTheExporter->OnPostExportLayer(type))
	{
		// We will not end up in fnBatchExportEnd, so clean-up here
		delete pTheExporter;
		pTheExporter = NULL;
		return false;
	}

	return true;
}


[!if SETTINGS_DIALOG]
//*******************************************************************************
// Name : fnSettings
// Desc : Display global settings dialog. If you have no global settings for your
//        loadre plug-in, remove this function entry from the exporter list
//        in '[!output SAFE_PROJECT_NAME].def'.
//*******************************************************************************
void __cdecl fnSettings()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	C[!output SAFE_PROJECT_NAME]Exporter::OnSettings();
}


[!endif]
