// ShapePointCreator.h: interface for the CShapePointCreator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SHAPEPOINTCREATOR_H__487122BF_65DC_4604_B616_754737A65624__INCLUDED_)
#define AFX_SHAPEPOINTCREATOR_H__487122BF_65DC_4604_B616_754737A65624__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CShapePointCreator  
{
public:
#pragma pack(push, SShapePointRecord)
#pragma pack(1)
	struct SShapePointRecord
	{
		// Record header information:
		size_t m_recordNumber;
		size_t m_contentLength;
		size_t IntShapeType;
		// Shapefile point data:
		double			   m_x;
		double			   m_y;
	};
#pragma pack(pop, SShapePointRecord)

	CShapePointCreator(size_t nRecordNumber);
	virtual ~CShapePointCreator();

	size_t GetAllocSizeBytes() const;

	bool Write(void* pMem, double x, double y);

	static void SetNewRecordNumber(void* pMem, size_t nRecordNumber);

	static void UpdateCoordinate(void* pMem, double x, double y);

	static inline size_t ByteSwitchInt(size_t n);

protected:
	size_t m_nRecordNumber;
};

inline size_t CShapePointCreator::ByteSwitchInt(size_t n)
{
	return	((n & 0x000000FF) << 24) |
			((n & 0x0000FF00) << 8) |
			((n & 0x00FF0000) >> 8) |
			((n & 0xFF000000) >> 24);
}

#endif // !defined(AFX_SHAPEPOINTCREATOR_H__487122BF_65DC_4604_B616_754737A65624__INCLUDED_)
