#ifndef _SHAPEPOLYGONCREATOR_H
#define _SHAPEPOLYGONCREATOR_H


class CShapePolygonCreator  
{
public:
#pragma pack(push, SShapePolygonRecord)
#pragma pack(1)
	struct SShapePolygonRecord
	{
		// Record header information:
		size_t m_recordNumber;
		size_t m_contentLength;
		size_t IntShapeType;
		// Shapefile polygon data:
		double			   m_xMin;
		double			   m_yMin;
		double			   m_xMax;
		double			   m_yMax;
		size_t 			   m_nPartCount;
		size_t 			   m_nPointCount;
		size_t			   m_parts[1];
	};
#pragma pack(pop, SShapePolygonRecord)

	CShapePolygonCreator(size_t nParts, size_t nTotalPointCount, size_t nRecordNumber);
	~CShapePolygonCreator();

	size_t GetAllocSizeBytes() const;

	void SetRecordNumber(size_t nRecordNumber);
	static void SetNewRecordNumber(void* pMem, size_t nRecordNumber);

	static void UpdateCoordinate(void* pMem, size_t nIndex, double x, double y);

	bool WriteHeader(void* pMem);
	bool WritePoint(double x, double y);
	bool WriteNewPart();

	bool Validate() { return m_nSuccessfullyWrittenPoints == m_nTotalPointCount; }

	static inline size_t ByteSwitchInt(size_t n);

protected:
	static void RecalcBoundingBox(void* pMem);

	size_t m_nParts, m_nTotalPointCount, m_nSuccessfullyWrittenPoints, m_nCurrentPart;
	size_t m_nRecordNumber;
	unsigned char *m_pMem;
	unsigned char* m_pNextPoint;
	bool m_bPointWritten;
};

inline size_t CShapePolygonCreator::ByteSwitchInt(size_t n)
{
	return	((n & 0x000000FF) << 24) |
			((n & 0x0000FF00) << 8) |
			((n & 0x00FF0000) >> 8) |
			((n & 0xFF000000) >> 24);
}

#endif // _SHAPEPOLYGONCREATOR_H
