// [!output SAFE_PROJECT_NAME].cpp : Defines the entry points for the DLL application.
//

#include "stdafx.h"
#include "./resource.h"
[!if SETTINGS_DIALOG]
#include "./SettingsDialog.h"
[!endif]


//--------------------------------------------------------
// Plug-in local data
//
[!if TOOLBAR]
SUToolBar toolbar;

[!endif]
// Every plug-in needs an instance of SUExport called suapi
SUExport suapi;

//--------------------------------------------------------
// Forward declarations
//
SURESULT __cdecl HookFunc(SUHANDLE hWorkspace, int hookType, SUHookData *args);
[!if SETTINGS_DIALOG]
void __cdecl OnSettings();
[!endif]
[!if TOOLBAR]
SURESULT OnToolBarButton(SUHANDLE hWorkspace, SUToolBarButtonHookData* args);
SURESULT OnIdle(SUHANDLE hWorkspace, SUHookData *args);
[!endif]
[!if JAVASCRIPT]
SURESULT OnJSInvoke(SUHANDLE hWorkspace, SUJavaScriptInvokeHookData *args);
[!endif]

//--------------------------------------------------------
// fnVersion()
//    Tells ShapeUp what version of the API we are aware
//    of.
//
size_t __cdecl fnVersion()
{
	return SHAPEUP_API_VERSION;
}


//--------------------------------------------------------
// fnGUID()
//    Identifies this plug-in.
//
const GUID* __cdecl fnGUID()
{
	// {[!output LIBID_REGISTRY_FORMAT]}
	static const GUID guid = 
		[!output LIBID_STATIC_CONST_GUID_FORMAT];
	return &guid;
}


//--------------------------------------------------------
// fnInit()
//    This function gets called just after the plug-in is
//    loaded in the ShapeUp start sequence.
//
SURESULT __cdecl fnInit(SUExport *pExport)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Tell ShapeUp who this plug-in is, and what it wants

	// Set some texts, which will be displayed here and there in ShapeUp
	pExport->import.pszName = "[!output PROJECT_NAME]";
	pExport->import.pszDescription = "A description of this Generic Plug-in.\nShort description";
	pExport->import.pszInfo = "Copyright (c) [!output YEAR]";
	pExport->import.pszPluginVersion = "1.00";

[!if SETTINGS_DIALOG]
	// Entry for our settings dialog
	pExport->import.pfnSettings = OnSettings;

[!endif]
	// Now keep the entire struct which is the actual ShapeUp API
	// (we need the function pointers later)
	::memcpy(&suapi, pExport, sizeof(SUExport));

	// Set-up our hooks
	pExport->import.pfnHook = HookFunc;

[!if TOOLBAR]
	// We want to get notified when the user presses our toolbar buttons
	ShapeUp_AddToolBarButtonHook(0);
	// The idle hook is used to set the state of toolbar buttons (disabled/checked/...)
	ShapeUp_AddIdleHook(0);

[!endif]
[!if JAVASCRIPT]
	// If someone invokes us using JavaScript we want to get notified
	const char* properties[] =
	{
		"color",
		NULL
	};
	const char* methods[] =
	{
		"getStringValue",
		NULL
	};
	ShapeUp_AddJavaScriptInvokeHook(0, properties, methods);

[!endif]
	// TODO: Set up your hooks here using the ShapeUp_AddXxxHook() functions

	return SURESULT_OK;
}


//--------------------------------------------------------
// fnTerminate()
//    This function gets called just before this plug-in
//    is unloaded by ShapeUp. Clean up whatever needs to
//    be cleaned up.
//
void __cdecl fnTerminate()
{
	// TODO: Add clean-up code if needed
}


//--------------------------------------------------------
// HookFunc()
//    This is our main function getting notified of state
//    changes in ShapeUp. We check the type of change, and
//    delegate.
//
SURESULT __cdecl HookFunc(SUHANDLE hWorkspace, int hookType, SUHookData *args)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	switch (hookType)
	{
		// TODO: Add hooks in fnInit, and respond to notifications here.
		//       See ShapeUpAPI documentation for details.
[!if TOOLBAR]
	case HOOKTYPE_TOOLBARBUTTON:
		return OnToolBarButton(hWorkspace, (SUToolBarButtonHookData*) args);
	case HOOKTYPE_IDLE:
		return OnIdle(hWorkspace, args);
[!endif]
[!if JAVASCRIPT]
	case HOOKTYPE_JAVASCRIPTINVOKE:
		return OnJSInvoke(hWorkspace, (SUJavaScriptInvokeHookData*)args);
[!endif]
	default:
		break;
	}

	return SURESULT_OK;
}


[!if SETTINGS_DIALOG]
//--------------------------------------------------------
// OnSettings()
//    Bring up a dialog.
//
void __cdecl OnSettings()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CSettingsDialog dlg;
	// TODO: Load settings into dlg
	if (dlg.DoModal() == IDOK)
	{
		// TODO: Store settings
	}
}


[!endif]
[!if TOOLBAR]
//--------------------------------------------------------
// OnToolBarButton()
//    This is where we end up when the user hits one of
//    our toolbar buttons.
//
SURESULT OnToolBarButton(SUHANDLE hWorkspace, SUToolBarButtonHookData* args)
{
	switch (args->nCommandID)
	{
	case ID_FIRST_TBBUTTON:
		// TODO: Add your message handler here
		break;
	case ID_SECOND_TBBUTTON:
		// TODO: Add your message handler here
		break;
	default:
		break;
	}

	return SURESULT_OK;
}


//--------------------------------------------------------
// OnIdle()
//    Handle toolbar button state (checked / inactive / ...)
//
SURESULT OnIdle(SUHANDLE hWorkspace, SUHookData *args)
{
	try
	{
		if (hWorkspace != NULL)
		{
			SUWorkspace workspace(hWorkspace);

			toolbar.SetButtonEnabled(ID_FIRST_TBBUTTON, true);
			toolbar.SetButtonEnabled(ID_SECOND_TBBUTTON, true);
		}
		else
		{
			toolbar.SetButtonEnabled(ID_FIRST_TBBUTTON, false);
			toolbar.SetButtonEnabled(ID_SECOND_TBBUTTON, false);
		}
	}
	catch (SUException &/*ex*/)
	{
	}

	return SURESULT_OK;
}


[!endif]
[!if JAVASCRIPT]
//--------------------------------------------------------
// OnJSInvoke()
//    Handle GPI plug-in invokation
//
SURESULT OnJSInvoke(SUHANDLE hWorkspace, SUJavaScriptInvokeHookData *args)
{
	// TODO: Change this code to reflect you needs

	// BLOCK: Sample code
	{
		static COLORREF myColor = RGB(0, 0, 0);
		if (0 == strcmp("color", args->name)) // Defined property
		{
			if (args->argc >= 1)
			{
				// Set value
				if (args->args[0].type != DT_COLOR)
					return SURESULT_E_ILLEGALPARAM;
				myColor = args->args[0].colorVal;
			}
			else
			{
				// Get value
				args->retc = 1;
				ShapeUp_Allocate(sizeof(SUJavaScriptArgument) * args->retc, (void**)&args->rets);

				args->rets[0].type = DT_COLOR;
				args->rets[0].colorVal = myColor;

				args->flags = JSIHDF_TREATRETURNASSINGLEVALUE;
			}
		}
		else if (0 == strcmp("getStringValue", args->name)) // Defined function
		{
			// Set-up return value
			args->retc = 1;
			ShapeUp_Allocate(sizeof(SUJavaScriptArgument) * args->retc, (void**)&args->rets);

			args->rets[0].type = DT_STRING;
			args->rets[0].stringVal = ShapeUp_DuplicateString("A string");

			args->flags = JSIHDF_TREATRETURNASSINGLEVALUE;
		}
	}

	return SURESULT_OK;
}


[!endif]
