// [!output SAFE_PROJECT_NAME].cpp : Defines the entry points for the DLL application.
//

#include "stdafx.h"
#include "ldrdef.h"

#include "[!output SAFE_PROJECT_NAME]Loader.h"
#include "[!output SAFE_PROJECT_NAME]Theme.h"



//*******************************************************************************
// Name : ThemeKeyData
// Desc : 
//*******************************************************************************
struct ThemeKeyData
{
	C[!output SAFE_PROJECT_NAME]Loader loader;
	C[!output SAFE_PROJECT_NAME]Theme  theme;
};


//*******************************************************************************
// Name : fnGetName
// Desc : This is a user friendly name used in menues and else-where in ShapeUp.
//*******************************************************************************
const wchar_t* __cdecl fnGetName()
{
	return C[!output SAFE_PROJECT_NAME]Loader::GetName();
}


//*******************************************************************************
// Name : fnGetLastErrMsg
// Desc : Return the last encountered error.
//*******************************************************************************
const wchar_t* __cdecl fnGetLastErrMsg()
{
	return C[!output SAFE_PROJECT_NAME]Loader::GetLastErrMsg();
}


//*******************************************************************************
// Name : fnGetInfo
// Desc : Information displayed if the user choses info from Tools|Options
//*******************************************************************************
const wchar_t* __cdecl fnGetInfo()
{
	return C[!output SAFE_PROJECT_NAME]Loader::GetInfo();
}


//*******************************************************************************
// Name : fnSupportsType
// Desc : What types of object do this loader suport.
//*******************************************************************************
bool __cdecl fnSupportsType(ShapeType t)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	return C[!output SAFE_PROJECT_NAME]Loader::SupportsType(t);
}


//*******************************************************************************
// Name : fnThemeCount
// Desc : Returns the number of themes we want to load of each supported type.
//*******************************************************************************
size_t __cdecl fnThemeCount(ShapeType t)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	return C[!output SAFE_PROJECT_NAME]Loader::GetThemeCount(t);
}


//*******************************************************************************
// Name : fnVersion
// Desc : Curent loader interface version.
//*******************************************************************************
size_t __cdecl fnVersion()
{
	return LOADER_PLUGIN_INTERFACE_VERSION;
}


//*******************************************************************************
// Name : fnPreLoadShapes
// Desc : Perform any actions before we start loading shapes. This could infact
//        mean we need to load all shapes 
//*******************************************************************************
bool __cdecl fnPreLoadShapes()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	return C[!output SAFE_PROJECT_NAME]Loader::OnPreLoadShapes();
}


//*******************************************************************************
// Name : fnLoadShapes
// Desc : Handle shape loading.
//*******************************************************************************
bool __cdecl fnLoadShapes(LoadShapeInfo *pInfo)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	ThemeKeyData *pTK = new ThemeKeyData;

	if (pTK->loader.OnLoadShapes(pInfo, pTK->theme))
	{
		pInfo->ulThemeKey = reinterpret_cast<unsigned long>(pTK);
		return true;
	}

	// Clean up
	delete pTK;
	return false;
}


//*******************************************************************************
// Name : fnRemoveShapes
// Desc : Clean-up this theme
//*******************************************************************************
void __cdecl fnRemoveShapes( unsigned long ulThemeKey )
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	ThemeKeyData *pTK = reinterpret_cast<ThemeKeyData*>(ulThemeKey);

	delete pTK;
}


[!if SUPPORTS_ATTRIBUTES]
//*******************************************************************************
// Name : fnGetAttributeCount
// Desc : 
//*******************************************************************************
size_t __cdecl fnGetAttributeCount(unsigned long ulThemeKey)
{
	ThemeKeyData *pTK = reinterpret_cast<ThemeKeyData*>(ulThemeKey);

	return pTK->theme.GetAttributeCount();
}


//*******************************************************************************
// Name : fnGetAttributeName
// Desc : 
//*******************************************************************************
const char* __cdecl fnGetAttributeName(unsigned long ulThemeKey, size_t nCol)
{
	ThemeKeyData *pTK = reinterpret_cast<ThemeKeyData*>(ulThemeKey);

	return pTK->theme.GetAttributeName(nCol);
}


//*******************************************************************************
// Name : fnGetAttributeType
// Desc : 
//*******************************************************************************
unsigned long __cdecl fnGetAttributeType(unsigned long ulThemeKey, size_t nCol)
{
	ThemeKeyData *pTK = reinterpret_cast<ThemeKeyData*>(ulThemeKey);

	return pTK->theme.GetAttributeType(nCol);
}


//*******************************************************************************
// Name : fnGetAttribute
// Desc : 
//*******************************************************************************
const char* __cdecl fnGetAttribute(unsigned long ulThemeKey, CShapeRecord *pShape, size_t nCol)
{
	ThemeKeyData *pTK = reinterpret_cast<ThemeKeyData*>(ulThemeKey);

	return pTK->theme.GetAttribute(pShape, nCol);
}


[!endif]
[!if SETTINGS_DIALOG]
//*******************************************************************************
// Name : fnSettings
// Desc : Display global settings dialog. If you have no global settings for your
//        loadre plug-in, remove this function entry from the exporter list
//        in '[!output SAFE_PROJECT_NAME].def'.
//*******************************************************************************
void __cdecl fnSettings()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	C[!output SAFE_PROJECT_NAME]Loader::OnSettings();
}


[!endif]


[!if CUSTOM_MENU_SUPPORT]
//*******************************************************************************
// Name : fnGetCustomMenu
// Desc : Returns menues related to current theme. A NULL value return means
//        no custom menu.
//*******************************************************************************
CustomMenuItem* __cdecl fnGetCustomMenu(unsigned long ulThemeKey)
{
	ThemeKeyData *pTK = reinterpret_cast<ThemeKeyData*>(ulThemeKey);

	return pTK->loader.GetCustomMenu(pTK->theme);
}


//*******************************************************************************
// Name : fnHandleCustomEvent
// Desc : 
//*******************************************************************************
long __cdecl fnHandleCustomEvent(CustomEventInfo *pInfo)
{
	ThemeKeyData *pTK = reinterpret_cast<ThemeKeyData*>(pInfo->ulThemeKey);

	return pTK->loader.OnCustomEvent(pTK->theme, pInfo);
}


[!endif]
