#pragma once

#include "shapeobjects.h"
#include "ldrdef.h"

#include <string>

class C[!output SAFE_PROJECT_NAME]Theme;

class C[!output SAFE_PROJECT_NAME]Loader
{
public:
	C[!output SAFE_PROJECT_NAME]Loader(void);
	~C[!output SAFE_PROJECT_NAME]Loader(void);

	static const wchar_t* GetName();
	static const wchar_t* GetLastErrMsg();
	static const wchar_t* GetInfo();

	static bool SupportsType(ShapeType t);
	static size_t GetThemeCount(ShapeType t);

	static bool OnPreLoadShapes();

[!if SETTINGS_DIALOG]
	static void OnSettings();

[!endif]
	bool OnLoadShapes(LoadShapeInfo *pInfo, C[!output SAFE_PROJECT_NAME]Theme &theme);

	static CShapeRecord* CreateShape(size_t nBytesRequired);
	static void DeleteShape(CShapeRecord *pShape);

[!if CUSTOM_MENU_SUPPORT]
	CustomMenuItem* GetCustomMenu(C[!output SAFE_PROJECT_NAME]Theme &theme);
	long OnCustomEvent(C[!output SAFE_PROJECT_NAME]Theme &theme, CustomEventInfo *pInfo);

[!endif]
protected:
	static std::wstring g_strErr;
[!if LOAD_POINT]
	static size_t g_nNumberOfPointLayers;
[!endif]
[!if LOAD_POLYLINE]
	static size_t g_nNumberOfPolylineLayers;
[!endif]
[!if LOAD_POLYGON]
	static size_t g_nNumberOfPolygonLayers;
[!endif]
[!if FILE_SUPPORT]
	static std::string g_strFileName;
[!endif]
};
