#include "StdAfx.h"
#include "./[!output SAFE_PROJECT_NAME]theme.h"
#include "./ldrdef.h"
#include "./[!output SAFE_PROJECT_NAME]loader.h"


//*******************************************************************************
// Name : C[!output SAFE_PROJECT_NAME]Theme
// Desc : Constructor
//*******************************************************************************
C[!output SAFE_PROJECT_NAME]Theme::C[!output SAFE_PROJECT_NAME]Theme(void)
{
}


//*******************************************************************************
// Name : ~C[!output SAFE_PROJECT_NAME]Theme
// Desc : Destructor
//*******************************************************************************
C[!output SAFE_PROJECT_NAME]Theme::~C[!output SAFE_PROJECT_NAME]Theme(void)
{
	for (size_t i = 0; i < m_vecShapes.size(); ++i)
		C[!output SAFE_PROJECT_NAME]Loader::DeleteShape(m_vecShapes[i]);
}


//*******************************************************************************
// Name : AddShape
// Desc : 
//*******************************************************************************
void C[!output SAFE_PROJECT_NAME]Theme::AddShape(CShapeRecord *pShape)
{
	ASSERT(pShape->GetIndex() == m_vecShapes.size());

	m_vecShapes.push_back(pShape);
}


[!if SUPPORTS_ATTRIBUTES]
//*******************************************************************************
// Name : GetAttributeCount
// Desc : Return the number of attributes for this theme
//*******************************************************************************
size_t C[!output SAFE_PROJECT_NAME]Theme::GetAttributeCount() const
{
	// TODO: Correct return values to reflect number of attributes for each struct

	switch (m_themeId)
	{
[!if LOAD_POINT]
		case PointTheme_1:
			return 2;
[!endif]
[!if LOAD_POLYLINE]
		case PolylineTheme_1:
			return 2;
[!endif]
[!if LOAD_POLYGON]
		case PolygonTheme_1:
			return 2;
[!endif]
		default:
			break;
	}

	return 0;
}


[!endif]
[!if SUPPORTS_ATTRIBUTES]
//*******************************************************************************
// Name : GetAttributeName
// Desc : Return the names of the attribute at index nCol
//*******************************************************************************
const char* C[!output SAFE_PROJECT_NAME]Theme::GetAttributeName(size_t nCol) const
{
	// TODO: Correct return values to reflect the names of the attributes
	//       for each struct

	switch (m_themeId)
	{
[!if LOAD_POINT]
		case PointTheme_1:
			switch (nCol)
			{
			case 0: return "Attribute 1";
			case 1: return "Attribute 2";
			default: break;
			}
			break;
[!endif]
[!if LOAD_POLYLINE]
		case PolylineTheme_1:
			switch (nCol)
			{
			case 0: return "Attribute 1";
			case 1: return "Attribute 2";
			default: break;
			}
			break;
[!endif]
[!if LOAD_POLYGON]
		case PolygonTheme_1:
			switch (nCol)
			{
			case 0: return "Attribute 1";
			case 1: return "Attribute 2";
			default: break;
			}
			break;
[!endif]
		default:
			break;
	}
	return "###ERROR###";
}


[!endif]
[!if SUPPORTS_ATTRIBUTES]
//*******************************************************************************
// Name : GetAttributeType
// Desc : Return the type of the attribute at index nCol.
//        The return type is not crucial. AT_STRING will always work. However,
//        to get the best out of ShapeUps statistical module and query engine,
//        specifying attribute types as exactly as possible will give the best
//        results.
//*******************************************************************************
unsigned long C[!output SAFE_PROJECT_NAME]Theme::GetAttributeType(size_t nCol) const
{
	// TODO: Correct return values to reflect the value type of the attributes
	//       for each struct.
	// NOTE: Even though the storage may be char[], if it only contains
	//       integers, AT_INTEGER could be used.

	switch (m_themeId)
	{
[!if LOAD_POINT]
		case PointTheme_1:
			switch (nCol)
			{
			case 0: return AT_STRING;
			case 1: return AT_STRING;
			default: break;
			}
			break;
[!endif]
[!if LOAD_POLYLINE]
		case PolylineTheme_1:
			switch (nCol)
			{
			case 0: return AT_STRING;
			case 1: return AT_STRING;
			default: break;
			}
			break;
[!endif]
[!if LOAD_POLYGON]
		case PolygonTheme_1:
			switch (nCol)
			{
			case 0: return AT_STRING;
			case 1: return AT_STRING;
			default: break;
			}
			break;
[!endif]
		default:
			break;
	}

	ASSERT(FALSE);

	return AT_STRING;
}


[!endif]
[!if SUPPORTS_ATTRIBUTES]
//*******************************************************************************
// Name : GetAttribute
// Desc : 
//*******************************************************************************
const char* C[!output SAFE_PROJECT_NAME]Theme::GetAttribute(CShapeRecord *pShape, size_t nCol) const
{
	switch (m_themeId)
	{
[!if LOAD_POINT]
		case PointTheme_1:
			{
				PointTheme1Attributes *pAttr = reinterpret_cast<PointTheme1Attributes*>(pShape->GetExtraDataPtr());
				switch (nCol)
				{
				case 0: return pAttr->value1;
				case 1: return pAttr->value2;
				default: break;
				}
			}
			break;
[!endif]
[!if LOAD_POLYLINE]
		case PolylineTheme_1:
			{
				PolylineTheme1Attributes *pAttr = reinterpret_cast<PolylineTheme1Attributes*>(pShape->GetExtraDataPtr());
				switch (nCol)
				{
				case 0: return pAttr->value1;
				case 1: return pAttr->value2;
				default: break;
				}
			}
			break;
[!endif]
[!if LOAD_POLYGON]
		case PolygonTheme_1:
			{
				PolygonTheme1Attributes *pAttr = reinterpret_cast<PolygonTheme1Attributes*>(pShape->GetExtraDataPtr());
				switch (nCol)
				{
				case 0: return pAttr->value1;
				case 1: return pAttr->value2;
				default: break;
				}
			}
			break;
[!endif]
		default:
			break;
	}

	ASSERT(FALSE);

	return "###ERROR###";
}
[!endif]

