#pragma once

#include <vector>

class CShapeRecord;

class C[!output SAFE_PROJECT_NAME]Theme
{
public:
	C[!output SAFE_PROJECT_NAME]Theme(void);
	~C[!output SAFE_PROJECT_NAME]Theme(void);

	enum ThemeId
	{
		// TODO: Define your types of themes. Give them useful names.
[!if LOAD_POINT]
		PointTheme_1,
[!endif]
[!if LOAD_POLYLINE]
		PolylineTheme_1,
[!endif]
[!if LOAD_POLYGON]
		PolygonTheme_1
[!endif]
	};

[!if SUPPORTS_ATTRIBUTES]
	// TODO: Create an attribute struct for each theme type.
[!if LOAD_POINT]
	// Sample Point struct
	struct PointTheme1Attributes
	{
		char value1[8];
		char value2[16];
	};
[!endif]
[!if LOAD_POLYLINE]
	// Sample Polyline struct
	struct PolylineTheme1Attributes
	{
		char value1[8];
		char value2[16];
	};
[!endif]
[!if LOAD_POLYGON]
	// Sample Polygon struct
	struct PolygonTheme1Attributes
	{
		char value1[8];
		char value2[16];
	};
[!endif]
[!endif]

	inline void SetThemeId(ThemeId id);
	inline ThemeId GetThemeId() const;

	void AddShape(CShapeRecord *pShape);

	size_t GetShapeCount() const;

	CShapeRecord* GetShape(size_t nIndex);

[!if SUPPORTS_ATTRIBUTES]
	// Attribute functions
	size_t GetAttributeCount() const;
	const char* GetAttributeName(size_t nCol) const;
	unsigned long GetAttributeType(size_t nCol) const;
	const char* GetAttribute(CShapeRecord *pShape, size_t nCol) const;

[!endif]
protected:
	std::vector<CShapeRecord*> m_vecShapes;

	ThemeId m_themeId;
};


inline void C[!output SAFE_PROJECT_NAME]Theme::SetThemeId(C[!output SAFE_PROJECT_NAME]Theme::ThemeId id)
	{ m_themeId = id; }

inline C[!output SAFE_PROJECT_NAME]Theme::ThemeId C[!output SAFE_PROJECT_NAME]Theme::GetThemeId() const
	{ return m_themeId; }

inline size_t C[!output SAFE_PROJECT_NAME]Theme::GetShapeCount() const
	{ return m_vecShapes.size(); }

inline CShapeRecord* C[!output SAFE_PROJECT_NAME]Theme::GetShape(size_t nIndex)
	{ return m_vecShapes[nIndex]; }

