// [!output SAFE_PROJECT_NAME].cpp : Defines the entry points for the DLL application.
//

#include "stdafx.h"
#include "./stcdef.h"
[!if TOOLBAR_BITMAP]
#include "resource.h"
[!endif]
#include "[!output SAFE_PROJECT_NAME]Statistics.h"



//*******************************************************************************
// Name : pTheStatistics
// Desc : 
//*******************************************************************************
C[!output SAFE_PROJECT_NAME]Statistics *pTheStatistics = NULL;


//*******************************************************************************
// Name : fnGetName
// Desc : This is a user friendly name used in menues and else-where in ShapeUp.
//*******************************************************************************
const wchar_t* __cdecl fnGetName()
{
	return C[!output SAFE_PROJECT_NAME]Statistics::GetName();
}


//*******************************************************************************
// Name : fnGetDescription
// Desc : This is a one-line description of this Statistics used in ShapeUp.
//*******************************************************************************
const wchar_t* __cdecl fnGetDescription()
{
	return C[!output SAFE_PROJECT_NAME]Statistics::GetDescription();
}


//*******************************************************************************
// Name : fnGetInfo
// Desc : Information displayed if the user choses info from Tools|Options
//*******************************************************************************
const wchar_t* __cdecl fnGetInfo()
{
	return C[!output SAFE_PROJECT_NAME]Statistics::GetInfo();
}


//*******************************************************************************
// Name : fnPreCalculate
// Desc : Prepare for a new calculation.
//*******************************************************************************
void __cdecl fnPreCalculate()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	ASSERT(pTheStatistics == NULL);

	pTheStatistics = new C[!output SAFE_PROJECT_NAME]Statistics;
}


//*******************************************************************************
// Name : g_staticResultBuffer
// Desc : Static result message holder
//*******************************************************************************
std::string g_staticResultBuffer;


//*******************************************************************************
// Name : fnCalculate
// Desc : Perform calculation
//*******************************************************************************
const char* __cdecl fnCalculate()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	ASSERT(pTheStatistics != NULL);

	if (pTheStatistics == NULL)
		return "Internal plug-in error.";

	// Save result
	g_staticResultBuffer = pTheStatistics->OnCalculate();

	// Clean-up session
	delete pTheStatistics;
	pTheStatistics = NULL;

	// Return result
	return g_staticResultBuffer.c_str();
}


//*******************************************************************************
// Name : fnVersion
// Desc : Curent Statistics interface version.
//*******************************************************************************
size_t __cdecl fnVersion()
{
	return STATISTICS_PLUGIN_INTERFACE_VERSION;
}


//*******************************************************************************
// Name : fnPushValue
// Desc : Add a value to our calculation
//*******************************************************************************
bool __cdecl fnPushValue(const char* pszValue)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	ASSERT(pTheStatistics != NULL);

	if (pTheStatistics == NULL)
		return false;

	return pTheStatistics->OnPushValue(pszValue);
}


[!if TOOLBAR_BITMAP]
//*******************************************************************************
// Name : fnToolbarBitmap
// Desc : Return a bitmap for ShapeUp statistical toolbar
//*******************************************************************************
HBITMAP __cdecl fnToolbarBitmap()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	static HBITMAP hbm = ::CreateMappedBitmap(AfxGetResourceHandle(),
											  IDB_BITMAP,
											  0,
											  NULL,
											  0);

	return hbm;
}


[!endif]
[!if SETTINGS_DIALOG]
//*******************************************************************************
// Name : fnSettings
// Desc : Display global settings dialog. If you have no global settings for your
//        loadre plug-in, remove this function entry from the Statistics list
//        in '[!output SAFE_PROJECT_NAME].def'.
//*******************************************************************************
void __cdecl fnSettings()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	C[!output SAFE_PROJECT_NAME]Statistics::OnSettings();
}


[!endif]
